<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::reference_counter_kernel_1&lt; T, copy &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1reference__counter__kernel__1.html">reference_counter_kernel_1</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdlib_1_1reference__counter__kernel__1-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::reference_counter_kernel_1&lt; T, copy &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:ae3625b7bd3df876c077bcee09bd7aa7a"><td class="memItemLeft" align="right" valign="top">typedef T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1reference__counter__kernel__1.html#ae3625b7bd3df876c077bcee09bd7aa7a">type</a></td></tr>
<tr class="separator:ae3625b7bd3df876c077bcee09bd7aa7a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a70b9119e13062fe7a38f443336f9e5a2"><td class="memItemLeft" align="right" valign="top"><a id="a70b9119e13062fe7a38f443336f9e5a2"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>reference_counter_kernel_1</b> (const <a class="el" href="classdlib_1_1reference__counter__kernel__1.html">reference_counter_kernel_1</a> &amp;item)</td></tr>
<tr class="separator:a70b9119e13062fe7a38f443336f9e5a2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1cb250ef9482b4bc3f8335c88ccdd790"><td class="memItemLeft" align="right" valign="top"><a id="a1cb250ef9482b4bc3f8335c88ccdd790"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>clear</b> ()</td></tr>
<tr class="separator:a1cb250ef9482b4bc3f8335c88ccdd790"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2ae5092c9cc95ccbeb033779f067ae6c"><td class="memItemLeft" align="right" valign="top"><a id="a2ae5092c9cc95ccbeb033779f067ae6c"></a>
T &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>modify</b> ()</td></tr>
<tr class="separator:a2ae5092c9cc95ccbeb033779f067ae6c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a66c57870df1c7679e05858c7b08a3768"><td class="memItemLeft" align="right" valign="top"><a id="a66c57870df1c7679e05858c7b08a3768"></a>
const T &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>access</b> () const</td></tr>
<tr class="separator:a66c57870df1c7679e05858c7b08a3768"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:add6c1b7a200ebcfc5669d100ea8acf32"><td class="memItemLeft" align="right" valign="top"><a id="add6c1b7a200ebcfc5669d100ea8acf32"></a>
<a class="el" href="classdlib_1_1reference__counter__kernel__1.html">reference_counter_kernel_1</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (const <a class="el" href="classdlib_1_1reference__counter__kernel__1.html">reference_counter_kernel_1</a> &amp;rhs)</td></tr>
<tr class="separator:add6c1b7a200ebcfc5669d100ea8acf32"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a06310a16a99979b40fd1ebdaea2717af"><td class="memItemLeft" align="right" valign="top"><a id="a06310a16a99979b40fd1ebdaea2717af"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>swap</b> (<a class="el" href="classdlib_1_1reference__counter__kernel__1.html">reference_counter_kernel_1</a> &amp;item)</td></tr>
<tr class="separator:a06310a16a99979b40fd1ebdaea2717af"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:abd1ed4e4fe0496b90cda6a3cb018eeac"><td class="memItemLeft" align="right" valign="top"><a id="abd1ed4e4fe0496b90cda6a3cb018eeac"></a>
T *&#160;</td><td class="memItemRight" valign="bottom"><b>data</b></td></tr>
<tr class="separator:abd1ed4e4fe0496b90cda6a3cb018eeac"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aab5a917a19309d7cad97fa794ef1dfad"><td class="memItemLeft" align="right" valign="top"><a id="aab5a917a19309d7cad97fa794ef1dfad"></a>
unsigned long *&#160;</td><td class="memItemRight" valign="bottom"><b>count</b></td></tr>
<tr class="separator:aab5a917a19309d7cad97fa794ef1dfad"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af1ef37b1955ec23b3a6ce7618ec91516"><td class="memItemLeft" align="right" valign="top"><a id="af1ef37b1955ec23b3a6ce7618ec91516"></a>
copy&#160;</td><td class="memItemRight" valign="bottom"><b>copy_item</b></td></tr>
<tr class="separator:af1ef37b1955ec23b3a6ce7618ec91516"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Typedef Documentation</h2>
<a id="ae3625b7bd3df876c077bcee09bd7aa7a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae3625b7bd3df876c077bcee09bd7aa7a">&#9670;&nbsp;</a></span>type</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T, typename copy = copy_functor&lt;T&gt;&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">typedef T <a class="el" href="classdlib_1_1reference__counter__kernel__1.html">dlib::reference_counter_kernel_1</a>&lt; T, copy &gt;::<a class="el" href="classdlib_1_1reference__counter__kernel__1.html#ae3625b7bd3df876c077bcee09bd7aa7a">type</a></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">    INITIAL VALUE
         data = item of type T with its initial value
         count = 1

    CONVENTION
         data = pointer to item of type T
         count = number of references to *data

        if clear() threw an exception then count = 0 and data is not a 
        valid pointer
</pre><p> ! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="reference__counter__kernel__1_8h_source.html">reference_counter_kernel_1.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
